import sys                             # for exit()
from Tkinter          import *         # basic Tkinter
import copy
from spreadsheet.SSheetData import *
from GUI.SSGridView import *

__version__="0.7"

class Application:
  def __init__(self,root):
    self.root=root
    self.__apps=[]
    self.__ID=0

  def startPolyCell(self,rows=25,columns=15,cellHeight=18,
                    cellWidth=50):
    polyCell=PolyCell(self, self.__ID)

    #start a default gridview to observe the data:
    gridRoot = Toplevel(self.root) #Tk()
    gridRoot.protocol("WM_DELETE_WINDOW", wmQuit)
    gridViewTitle = "DSheet V" + __version__ + \
                    " <observing subject " + str(self.__ID) + ">"
    gridRoot.title(gridViewTitle)
    gridView = SpreadsheetGridView_Static(self.__ID,
                                          subject=polyCell,
                                          master=gridRoot,
                                          title=gridViewTitle,
                                          height=rows, width=columns,
                                          cellHeight=cellHeight,
					  cellWidth=cellWidth,
					  version=__version__)

    self.__apps.append(polyCell)
    self.__ID+=1

    try:
      gridRoot.mainloop()
    except KeyboardInterrupt:
      ctrlCQuit()

  def stopPolyCell(self, polyCell):
    self.__apps.remove(polyCell)
    if len(self.__apps)==0:
      sys.exit()

class PolyCell:

  def __init__(self, mainApp, ID):
    self.__subject=SSheetData()
    self.__ID=ID
    self.mainApp=mainApp

  def getID(self):
    return self.__ID

  def getState(self,maxCol,maxRow):
    return self.__subject.getCellsValue(maxCol,maxRow)

  def getValue(self, cellCoord):
    return self.__subject.getCellValue(cellCoord.col,
                                       cellCoord.row)

  def getFormula(self, cellCoord):
    return self.__subject.getCellFormula(cellCoord.col,
                                         cellCoord.row)

  def setState(self, cellCoord, formulaStr):
    self.__subject.setCell(cellCoord.col,
                           cellCoord.row,
                           formulaStr)

  def destroy(self):
    self.mainApp.stopPolyCell(self)

def ctrlCQuit():
  """
  Handle SIGINT signal: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by SIGINT signal)"
  sys.exit()

def wmQuit():
  """
  Handle root window close: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by Window Manager)"
  sys.exit()

def rootQuit():
  """
  Handle Quit clicked in root window: exit() application
  """
  # we may wish to put cleanup actions here
  print "Spreadsheet Application was closed (by Quit in root window)"
  sys.exit()

if __name__ == "__main__":
  # root window
  root=Tk()
  root.withdraw()
  mainApp=Application(root)
  mainApp.startPolyCell()


