import types

class FunctionArgError(Exception):
    """Raised when a incorrect arguments are passed to a function"""
    def __init__(self, msg=""):
        Exception.__init__(self)
        self.__msg=msg
    def __repr__(self):
        return self.__msg
    def __str__(self):
        return self.__msg

def sum(args):
    if len(args)==0:
        raise FunctionArgError("Need at least 1 argument")
    answer=args[0]
    if type(answer)==types.ListType:
        answer=sum(answer)
    for data in args[1:]:
        if type(data)==types.ListType:
            data=sum(data)
        answer+=data
    return answer

def mul(args):
    if len(args)==0:
        raise FunctionArgError("Need at least 1 argument")
    answer=args[0]
    if type(answer)==types.ListType:
        answer=mul(answer)
    for data in args[1:]:
        if type(data)==types.ListType:
            data=mul(data)
        answer*=data
    return answer

def exp(args):
    if len(args)==0:
        raise FunctionArgError("Need at least 1 argument")
    answer=args[0]
    if type(answer)==types.ListType:
        answer=exp(answer)
    for data in args[1:]:
        if type(data)==types.ListType:
            data=exp(data)
        answer=pow(answer,data)
    return answer

def invSum(args):
    if len(args)!=1:
        raise FunctionArgError("Need exactly 1 argument")
    else:
        return args[0]*-1

def invMul(args):
    if len(args)!=1:
        raise FunctionArgError("Need exactly 1 argument")
    else:
        return 1.0/args[0]
